/*
**	xdiff -- graphical diff for X
**	text.c: text user-interface implementation
**
**	Copyright (C) 1996  Paul J. Lucas
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 1, or (at your option)
**	any later version.
** 
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
** 
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* system */
#include <stdio.h>

/* local */
#include "data.h"
#include "util.h"

/*************************/
	void
text_output()
{
	int i, j;

	for ( i = 0; i < map.max_lines; ++i ) {
		static char buf[2][ 80 + 1 ];
		char diff[2];
		for ( j = 0; j <= 1; ++j ) {
			line_info const *line = map.set[i].line[j];
			if ( line ) {
				expand_tabs( line->text, buf[j], 80 );
				switch ( line->type ) {
					case same_line:	diff[j] = ' '; break;
					case diff_line:	diff[j] = 'C'; break;
					case new_line:
						diff[j] = j ? '>' : '<';
						break;
				}
			} else {
				/*
				** A line in the other file does not map to a
				** line in this file so we create a "hole."
				*/
				buf[j][0] = '\0';
				diff[j] = 'X';
			}
		}
		printf( "%c %-80s|%c %-80s\n",
			diff[0], buf[0], diff[1], buf[1]
		);
	}
}
